﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using SAPbobsCOM;

namespace TestSAPFunctionality
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }



        private void m_btnTest_Click(object sender, EventArgs e)
        {
            SAPbobsCOM.Company m_company = null;
            try
            {
                this.Cursor = Cursors.WaitCursor;

                m_company = new SAPbobsCOM.Company();
                //Set the company properties
                m_company.Server = m_txtServer.Text;
                m_company.CompanyDB = m_txtCompanyDB.Text;
                m_company.UseTrusted = false;
                m_company.DbUserName = m_txtDBUser.Text;
                m_company.DbPassword = m_txtDBPassword.Text;
                m_company.UserName = m_txtSAPUser.Text;
                m_company.Password = m_txtSAPPassword.Text;
				m_company.DbServerType = m_cmbDBType.SelectedIndex == 1 ? BoDataServerTypes.dst_MSSQL2008 : m_cmbDBType.SelectedIndex == 2 ? BoDataServerTypes.dst_MSSQL2012 : BoDataServerTypes.dst_MSSQL2005;
                m_company.LicenseServer = m_txtLicenseServer.Text;
                m_company.AddonIdentifier = "";
                //Connect
                //int error = m_company.Connect();
                if (m_company.Connect() != 0)
                {
                    //Error
                    MessageBox.Show("Error occured with code: " + m_company.GetLastErrorCode() + " " + m_company.GetLastErrorDescription());
                }
                else
                {
                    MessageBox.Show("Connected!");


					m_company.StartTransaction();

					ProductionOrders doc = (ProductionOrders)m_company.GetBusinessObject(BoObjectTypes.oProductionOrders);

					doc.GetByKey(Convert.ToInt32(m_txtProductionOrder.Text));

					doc.UserFields.Fields.Item("U_PMX_PRST").Value = "C";
					doc.ProductionOrderStatus = BoProductionOrderStatusEnum.boposClosed;

      
                    int error = doc.Update();
                    if (error != 0)
                    {
						m_company.EndTransaction(BoWfTransOpt.wf_RollBack);
                        //Error
                        MessageBox.Show("Error occured with code: " + m_company.GetLastErrorCode() + " " + m_company.GetLastErrorDescription());


                    }

					if (m_cbCommit.Checked)
					{
						m_company.EndTransaction(BoWfTransOpt.wf_Commit);
					}
					else
					{
						m_company.EndTransaction(BoWfTransOpt.wf_RollBack);
					}




                }

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
            finally
            {
                if (m_company != null)
                {
                    Application.DoEvents();

                    try
                    {
						if (m_company.InTransaction)
						{
							m_company.EndTransaction(BoWfTransOpt.wf_RollBack);
						}
                        m_company.Disconnect();
                        //cleanup
                        System.Runtime.InteropServices.Marshal.ReleaseComObject(m_company);
                        m_company = null;

                        MessageBox.Show("Disconnected!");

                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show(ex.ToString());
                    }



                }



                this.Cursor = Cursors.Default;
            }
        }


        /// <summary>
        /// Runs the SAPQ uery.
        /// </summary>
        /// <param name="query">The query.</param>
        private void RunSAPQUery(string query)
        {
            IRecordset rs = null;
            try
            {
                rs = RunQuery(query);

                //perform actions on recordset
                while (!rs.EoF)
                {
                    string test = rs.Fields.Item("Test").Value as string;


                    rs.MoveNext();
                }

            }
            finally
            {
                //cleanup recordset
                System.Runtime.InteropServices.Marshal.ReleaseComObject(rs);
                rs = null;

            }
        }

        /// <summary>
        /// Runs the query.
        /// </summary>
        /// <param name="query">The query.</param>
        /// <returns></returns>
        private IRecordset RunQuery(string query)
        {

            SAPbobsCOM.Company m_company = new SAPbobsCOM.Company();
            //Set the company properties
            m_company.Server = m_txtServer.Text;
            m_company.CompanyDB = m_txtCompanyDB.Text;
            m_company.UseTrusted = false;
            m_company.DbUserName = m_txtDBUser.Text;
            m_company.DbPassword = m_txtDBPassword.Text;
            m_company.UserName = m_txtSAPUser.Text;
            m_company.Password = m_txtSAPPassword.Text;
            m_company.DbServerType = m_cmbDBType.SelectedIndex == 1 ? BoDataServerTypes.dst_MSSQL2008 : BoDataServerTypes.dst_MSSQL2005;
            m_company.LicenseServer = m_txtLicenseServer.Text;

            //Connect
            int error = m_company.Connect();
            if (error != 0)
            {
                //Error
                MessageBox.Show("Error occured with code: " + m_company.GetLastErrorCode() + " " + m_company.GetLastErrorDescription());
            }
            else
            {


                IRecordset rs = (IRecordset)m_company.GetBusinessObject(SAPbobsCOM.BoObjectTypes.BoRecordset);

                //When doing tracing we see that for every SELECT SAP does 3 statements:
                // -exec sp_prepare @p1 output,NULL,N'SELECT * FROM [TABLENAME] FOR BROWSE ',1
                // -exec [sys].sp_pkeys N'TABLENAME',N'dbo',NULL
                // -exec sp_prepexec @p1 output,NULL,N'SELECT * FROM [TABLENAME] FOR BROWSE '
                // -> It always get the primary key of the table.
                // -> We don't need this. Because of this we use the EXEC sp_executesql
                StringBuilder newQuery = new StringBuilder(254);
                newQuery.Append("EXECUTE(");
                newQuery.Append(query);
                newQuery.Append(")");
                rs.DoQuery(newQuery.ToString());

                return rs;
            }

            return null;


        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.m_cmbDBType.SelectedIndex = 2;
        }


    }
}
